//,=== DSI_source_test ===
void cursor_ping_pong () {
  int x = 0, y = 0, i;
  int dir_x,dir_y;
  
  SYSTEM.VPOUT[0].cursor_setup(1, 1, 0, 0, 0x00000000, 0x00ffffff);
  SYSTEM.VPOUT[0].LCDPALETTEMEM[0] = 0xff00;
  SYSTEM.VPOUT[0].LCDPALETTEMEM[1] = 0xA0A0A0;
  
  while (1) {
    SYSTEM.VPOUT[0].wait_numb_frame(1, 0);
    
    if (x==0) dir_x = 1;
    else if (x>=1023) dir_x = 0;

    if (y==0) dir_y = 1;
    else if (y>=1860) dir_y = 0;
    
    if (dir_x == 1) x=x+3;
    else if (dir_x == 0) x=x-3;
    
    if (dir_y == 1) y=y+3;
    else if (dir_y == 0) y=y-3;
    
    SYSTEM.VPOUT[0].cursor_move(x,y); 
  }
}

#define VPOUT_WAIT_NUM_FRAME	3
#define AXI_CLK_MHZ	432
//,==== test1 - DSI non-burst mode with sync pulses ====
//, Проверка работы DSI в режиме non-burst with sync pulses
//, Алгоритм:
int DSI_source_test(void){
  int errors = 0, ab0_addr, ab1_addr, DIV = 2;
  short int hsw = 9, hgdel = 49, hgate = 1079, hlen = 1239, vsw = 1, vgdel = 3, vgate = 1919, vlen = 1929;
  
  //,# Задержка на инициализацию DSI (> 335 мкс)
  sleep_timer(340000, true);
  
  print_val(0x1001);
//,# Быстрая инициализация памяти видеобуфера
  ab0_addr = 0x3b000000;
  ab1_addr = 0x3b000000;
  print_val(ab0_addr);
  print_val(ab1_addr);
  
  print_val(0xAAAAA0);
//,# Установка рабочих частот видеовыхода (CPLL = AXI_CLK_MHZ)
  SYSTEM.CMCTR[0].set_cpll_mult_in_mhz(AXI_CLK_MHZ);
  
//,# Конфигурация DSI:
  print_val(0xAAAAA2);
  DSI_config_type dsi_config;
//,## Чтение базовой конфигурации
  SYSTEM.DSI[0].get_config((int *)&dsi_config);
//,## Установка базовой конфигурации:
//,##* Число линий: 2
  dsi_config.data_lines = DSI_DataLines_4;
//,##* Виртуальный канал для режима видео: 0
  dsi_config.ch_video_mode = DSI_virt_ch_0;
//,##* Виртуальный канал для режима команд: 1
  dsi_config.ch_cmd_mode = DSI_virt_ch_1;
//,##* Глубина цвета для режима видео: RGB888
  dsi_config.video_format = DSI_video_format_RGB888;
//,##* Размер данных в режиме команд: выключено
  dsi_config.cmd_data_width = DSI_cmd_data_none;
  
//,##* Установка базовых таймингов:
//,##** hs_tx_timeout: 0xFFFFFF
  dsi_config.hs_tx_timeout = 0xFFFFFF;
//,##** lp_rx_timeout: 0xFFFFFF
  dsi_config.lp_rx_timeout = 0xFFFFFF;
//,##** turn_around_timeout: 0x1F
  dsi_config.turn_around_timeout = 0x1F;
//,##** dev_reset_timer: 0xFF
  dsi_config.dev_reset_timer = 0xFF;
//,##** init_counter: 0x7D0
  dsi_config.init_counter = 0x7D0;
  
//,##* Режим работы: non-burst with sync pulses
  dsi_config.video_mode = DSI_vd_mode_non_burst_sync_pulse;
//,##* Bus Turn-Around: выключено
  dsi_config.clk_eot_reg = DSI_clk_eot_BTA_disable;
//,##* Полярность: Vsync
  dsi_config.polarity = 0;
//,##* Авто восстановление ошибок: Ecc_mul_err_clr
  dsi_config.err_auto_recovery = DSI_err_auto_rec_ecc_mul;
//  SYSTEM.DSI[0].set_reduce_config((int *)&dsi_config);
  SYSTEM.DSI[0].set_config((int *)&dsi_config);
//  SYSTEM.DSI[0].maskIrq(0xFFFFFFFF);
  
//,## Рассчет PCLK
  print_val(0xAAAAA3);
  int ddr_freq, t_byteclk;
  float pclk_freq;
  pclk_freq = (float)AXI_CLK_MHZ/(DIV + 1);
//,## Автоматический рассчет DDR_CLK
  ddr_freq =  SYSTEM.DSI[0].set_auto_ddr_clk_freq(pclk_freq);
  t_byteclk = SYSTEM.DSI[0].get_t_byteclk();
//,## Печать DDR_CLK и BYTE_CLK
  print_val(ddr_freq);	// 432 MHz
  print_val(t_byteclk);
  
//,## Установка dpi-разрешения кадра
  dsi_config.DPI_resolution_h = hgate + 1;
  dsi_config.DPI_resolution_v = vgate + 1;
  dsi_config.HSYNC_count = hsw + 1;
  dsi_config.HSYNC_bpc = hgdel + 1;
  dsi_config.HSYNC_fpc = (hlen + 1) - (hgate + 1) - (hgdel + 1) - (hsw + 1);
  dsi_config.HSYNC_aac = hgate + 1;
  dsi_config.VSYNC_count = vsw + 1;
  dsi_config.VSYNC_bpc = vgdel + 1;
  dsi_config.VSYNC_fpc = (vlen + 1) - (vgate + 1) - (vgdel + 1) - (vsw + 1);
  SYSTEM.DSI[0].set_dpi_resolution((int *)&dsi_config);
  
  print_val(0xAAAAA4);
//,## Автоматический рассчет таймингов DPHY
  SYSTEM.DSI[0].set_auto_dphy_timing();
  
//,## Отладочная печать автоматически рассчитаных таймингов
  SYSTEM.DSI[0].get_config((int *)&dsi_config);
  print_val(dsi_config.LP_byteclk);
  print_val(dsi_config.dphy_hs_prep);
  print_val(dsi_config.dphy_hs_zero);
  print_val(dsi_config.dphy_hs_trail);
  print_val(dsi_config.dphy_hs_exit);
  
  print_val(dsi_config.clk_hs_prep);
  print_val(dsi_config.clk_hs_zero);
  print_val(dsi_config.clk_hs_trail);
  print_val(dsi_config.clk_hs_exit);
  
  print_val(dsi_config.lane_high_low_switch_count);
  print_val(dsi_config.hs_to_lp_switch_count);
  print_val(dsi_config.lp_to_hs_switch_count);
  
//,## Установка базовой частоты DSI
  print_val(0xAAAAA5);
  SYSTEM.DSI[0].set_pll_div_ratio(ddr_freq/12);	//41 max
  print_val(SYSTEM.DSI[0].get_pll_div_ratio());
  
//,# Запуск DSI
  print_val(0xAAAAA6);
  SYSTEM.DSI[0].enable_DFE();
  SYSTEM.DSI[0].enable();
  
//,# Задержка на инициализацию DSI (> 335 мкс)
  sleep_timer(340, true);
  
//,# Печать базовых адресов VPOUT
  print_val(0xAAAAA7);
  print_val(SYSTEM.VPOUT[0].get_regs_mem_addr());
  print_val(SYSTEM.VPOUT[0].get_palette_mem_addr());
  print_val(SYSTEM.VPOUT[0].get_cursor_mem_addr());
  
//,# Конфигурация VPOUT:
//,## Включение
  print_val(0xAAAAA8);
  SYSTEM.VPOUT[0].enable();
  
//,## Установка режима работы:
//,##* Глубина цвета: 32bpp
//,##* Курсор: выключен
//,##* Число буферов: 2
  print_val(0xAAAAA9);
  SYSTEM.VPOUT[0].configure_base(ab0_addr, ab1_addr, hsw, hgdel, hgate, hlen, vsw, vgdel, vgate, vlen, DIV);
  SYSTEM.VPOUT[0].set_mode(8, vpout_cursor_on, vpout_cursor_64x64, 0,
			   0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1);
  
  report_high("init mem");
  char * vptr = (char *)0x3b000000;
  print_val(int(vptr));
  print_val(0x3b000000);
  for (int i=0; i<1920; i++){
    for (int j=0; j<1088/8; j++){
      if      (i>10  && i<20 ) vptr[i*136+j] = 0xff;
      else if (i>300 && i<400) vptr[i*136+j] = 0xff;
      else                     vptr[i*136+j] = 0x00;
    }
  }
  
//,# Запуск VPOUT
  print_val(0xAAAAAB);
  SYSTEM.DSI[0].DSICONTROLLER->DPI_CONTROL_REG = 2;	// Turn On
  SYSTEM.VPOUT[0].start();
  
  // Wait min 120 ms to display on
  sleep_timer(1000000, true);
  
  cursor_ping_pong();
  return errors;
}